#include <stdio.h>
int main()
{
	int N,i;
	int Oj,Aj,Bj,ABj;
	int O,A,B,AB;
	int Ap,Bp,ABp,Op;
	scanf("%d",&N);
	char Pac[N];
	int BrojG[N];
	int UkpP=0;
	scanf("%d %d %d %d",&Oj,&Aj,&Bj,&ABj);
	for(i=0;i<N;i++)
	{
		scanf("%s %d",&Pac[i],&BrojG[i]);
		if(Pac[i]=='A')
		{
			int Ap=BrojG[i];
		}
		if(Pac[i]=='B')
		{
			int Bp=BrojG[i];
		}
		if(Pac[i]== "AB")
		{
			int ABp=BrojG[i];
		}
		if(Pac[i]=='O')
		{
			int Op=BrojG[i];
		}
	}
	for(i=0;i<N;i++)
	{
		UkpP=UkpP+BrojG[i];
	}
	if(UkpP>Oj+Aj+Bj+ABj)
	{
		printf("Nemoguce");
	}
	else
	{
		if(Op==Oj)
		{
			O=Oj;	
		}
		if(Ap==Aj || Ap==Oj)
		{
			A=Aj+Oj;
		}
		if(Bp==Bj || Bp==Oj)
		{
			B=Bj+Oj;
		}
		if(ABp==ABj || ABp==Aj || ABp==Bj || ABp==Oj)
		{
			AB=ABj+Bj+Aj+Oj;
		}
		printf("Moguce");
	}
	return 0;
}